/**  
* <p>Title: CrmClientData.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年6月5日  
* @version 1.0  
*/
package cn.timer.api.bean.crm;

import java.util.Date;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * <p>
 * Title: CrmClientData.java
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author dsc
 * @date 2020年6月5日
 * @version 1.0
 */

@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "crm_client_data")
@ApiModel("客户数据表")
public class CrmClientData extends Model<CrmClientData> {

	private static final long serialVersionUID = -5368056704790782781L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;

	@ApiModelProperty(value = "客户姓名")
	private String clientName;

	@ApiModelProperty(value = "客户手机号")
	private String clientCellphone;

	@ApiModelProperty(value = "客户座机")
	private String clientTelephone;

	@ApiModelProperty(value = "客户官网")
	private String clientUrl;

	@ApiModelProperty(value = "行业id(字典表)")
	private Integer industry;

	@ApiModelProperty(value = "行业名")
	private String industryName;

	@ApiModelProperty(value = "客户邮箱")
	private String clientEmail;

	@ApiModelProperty(value = "省")
	private String province;
	@ApiModelProperty(value = "省id")
	private Integer provinceId;
	@ApiModelProperty(value = "市")
	private String city;
	@ApiModelProperty(value = "市")
	private Integer cityId;
	@ApiModelProperty(value = "区")
	private String district;
	@ApiModelProperty(value = "区编号")
	private Integer districtId;
	@ApiModelProperty(value = "邮编")
	private String zipCode;
	@ApiModelProperty(value = "详细地址")
	private String address;

	@ApiModelProperty(value = "客户类型id")
	private Integer clientType;

	@ApiModelProperty(value = "客户类型名")
	private String clientTypeName;

	@ApiModelProperty(value = "客户来源id")
	private Integer clientSource;

	@ApiModelProperty(value = "客户来源名")
	private String clientSourceName;

	@ApiModelProperty(value = "备注")
	private String remarks;

	@ApiModelProperty(value = "客户所属(创建人empNum) 0-进入客户公海")
	private Integer belongUser;

	@ApiModelProperty(value = "客户所属人姓名")
	private String belongUserName;

	@ApiModelProperty(value = "客户所属业务组id")
	private Integer belongGroup;

	@ApiModelProperty(value = "客户所属业务组名")
	private String belongGroupName;

	@ApiModelProperty(value = "客户数据状态 0-无 1-潜在 2-意向 3-签约 4-合作中 5-已封档")
	private Integer clientStatus;

	@ApiModelProperty(value = "附件地址")
	private String fileUrl;

	@ApiModelProperty(value = "客户联系人数量")
	private Integer contactsNum;

	@ApiModelProperty(value = "收藏关注 0-否 1-是")
	private Integer star;

	@ApiModelProperty(value = "创建人")
	private Integer createUser;

	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value = "创建时间")
	private Date createTime;

	@ApiModelProperty(value = "修改人")
	private Integer modifyUser;

	@TableField(fill = FieldFill.INSERT_UPDATE)
	@ApiModelProperty(value = "修改时间")
	private Date modifyTime;

	@ApiModelProperty(value = "最近跟进时间")
	private Date lastFollowTime;

	@ApiModelProperty(value = "企业id")
	private Integer orgCode;
	
	@ApiModelProperty(value = "微信")
	private String wechat;
	
	@ApiModelProperty(value = "产品")
	private String product;
	
	@ApiModelProperty(value = "跟进记录")
	private String followuprecord;
	
	@ApiModelProperty(value = "隐藏客户（0：已隐藏；1：未隐藏）")
	private Integer hidingcustomers;

	@Transient
	@TableField(exist = false)
	@ApiModelProperty(value = "协作(0：否 1：是)")
	private Integer iscooperation;
	
	@Transient
	@TableField(exist = false)
	@ApiModelProperty(value = "协作人id")
	private Integer[] ids;

	@Transient
	@TableField(exist = false)
	@ApiModelProperty(value = "客户联系人数据列表")
	private List<CrmClientContacts> CrmClientContacts;
}
