/**  
* Title: CrmClientFollow.java 
* Description: 
* @author dsc  
* @date 2020年6月8日  
* @version 1.0  
*/
package cn.timer.api.bean.crm;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * Title: CrmClientPlan.java
 * 
 * @Description:
 * @author wuqingjun
 * @date 2023年5月12日
 * @version 1.0
 */

@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "crm_client_plan")
@ApiModel("客户管理-跟进计划")
public class CrmClientPlan extends Model<CrmClientPlan> {

	private static final long serialVersionUID = -7362549097557018583L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;

	@ApiModelProperty(value = "客户数据id")
	private Integer cid;

	@ApiModelProperty(value = "内容")
	private String content;

	@ApiModelProperty(value = "备注")
	private String remake;

	@ApiModelProperty(value = "创建人")
	private Integer createUser;

	@ApiModelProperty(value = "创建人姓名")
	private String createUserName;

	@ApiModelProperty(value = "创建人手机号码")
	private String createUserPhone;

	@ApiModelProperty(value = "企业id")
	private Integer orgCode;

	@ApiModelProperty(value = "执行时间")
	private Date executeTime;
	
	@ApiModelProperty(value = "状态：0.未提醒 1.已提醒")
	private Integer status;

	@ApiModelProperty(value = "是否短信提醒：0否，1是")
	private Integer ifWarnSms;

	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value = "提醒时间")
	private Date warnTime;

	@ApiModelProperty(value = "创建时间")
	private Date createTime;

	@ApiModelProperty(value = "更新时间")
	private Date updateTime;

}
