package cn.timer.api.bean.insure;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;



/**
 * 保单信息
 *
 * @author wgd
 * @email 862422848@qq.com
 * @date 2022-03-14 08:53:04
 */
@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "insure_policy")
@ApiModel("保单信息")
public class InsurePolicy extends Model<InsurePolicy> {
	private static final long serialVersionUID = 1L;

	/**
	*
	*/
	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;
	/**
	* 方案名称(必选)
	*/
	private String schemeName;
	/**
	* 保单生效日
	*/
	private Date policyDateStart;
	/**
	* 保单终止日
	*/
	private Date policyDateEnd;
	/**
	* 产品代码
	*/
	private String productCodeId;
	/**
	* 计划代码
	*/
	private String planCodeId;
	/**
	* 分销商pid
	*/
	private String partnerPid;
	/**
	* 保单号
	*/
	private String policyNo;
	/**
	* 保单类型：1、年单 2、月单
	*/
	private Integer type;
	/**
	* 5-人民币，其他币种请参见全局数据字典
	*/
	private String currency;
	/**
	* 总保费


	*/
	private String totalPremium;
	/**
	* 1-正常 2-等待校验 3-失效 4支付中
	*/
	private String status;
	/**
	* 电子保单
	*/
	private String policyFile;
	/**
	* 保单kit的地址
	*/
	private String kitUrl;
	/**
	* 投保人id
	*/
	private Integer insureApplicantId;
	/**
	* 企业id
	*/
	private Integer orgCode;
	/**
	* 投保时间
	*/
	private Date createTime;
	/**
	 * 最近操作时间
	 */
	private Date updateTime;

	private Integer productId;

	/**
	 * 1在线支付 2预付款 3线下支付
	 */
	private Integer policyPayType;
	/**
	 * insure_pay表的id
	 */
	private Integer payId;

	private String serialNumber;


}
