package cn.timer.api.bean.spmk;

import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;


/**
 * 审批执行记录 发起人、抄送人、审批人操作记录--草稿
 *
 * @author wgd
 * @email 862422848@qq.com
 * @date 2022-08-19 14:53:36
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "spmk_approve_execute_record_drafts")
@ApiModel("审批执行记录 发起人、抄送人、审批人操作记录--草稿")
public class SpmkApproveExecuteRecordDrafts extends Model<SpmkApproveExecuteRecordDrafts> implements Serializable {
	private static final long serialVersionUID = 1L;

	/**
	* 编号
	*/
	private Integer id;
	/**
	* 审批汇总id
	*/
	private Integer approveSummaryId;
	/**
	* 名称 发起申请 1抄送人 审批人 连续多级主管
	*/
	private String name;
	/**
	* 类型 0发起申请 1抄送人 2审批人 3连续多级主管
	*/
	private Integer type;
	/**
	* 状态 0未执行 1审批中 2同意 3拒绝
	*/
	private Integer sts;
	/**
	* 创建时间
	*/
	private Date createTime;
	/**
	*
	*/
	private Date updateTime;

	/**
	 * 设置：编号
	 */
	public void setId(Integer id) {
		this.id = id;
	}
	/**
	 * 获取：编号
	 */
	public Integer getId() {
		return id;
	}
	/**
	 * 设置：审批汇总id
	 */
	public void setApproveSummaryId(Integer approveSummaryId) {
		this.approveSummaryId = approveSummaryId;
	}
	/**
	 * 获取：审批汇总id
	 */
	public Integer getApproveSummaryId() {
		return approveSummaryId;
	}
	/**
	 * 设置：名称 发起申请 1抄送人 审批人 连续多级主管
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * 获取：名称 发起申请 1抄送人 审批人 连续多级主管
	 */
	public String getName() {
		return name;
	}
	/**
	 * 设置：类型 0发起申请 1抄送人 2审批人 3连续多级主管
	 */
	public void setType(Integer type) {
		this.type = type;
	}
	/**
	 * 获取：类型 0发起申请 1抄送人 2审批人 3连续多级主管
	 */
	public Integer getType() {
		return type;
	}
	/**
	 * 设置：状态 0未执行 1审批中 2同意 3拒绝
	 */
	public void setSts(Integer sts) {
		this.sts = sts;
	}
	/**
	 * 获取：状态 0未执行 1审批中 2同意 3拒绝
	 */
	public Integer getSts() {
		return sts;
	}
	/**
	 * 设置：创建时间
	 */
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	/**
	 * 获取：创建时间
	 */
	public Date getCreateTime() {
		return createTime;
	}
	/**
	 * 设置：
	 */
	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}
	/**
	 * 获取：
	 */
	public Date getUpdateTime() {
		return updateTime;
	}
}
