package cn.timer.api.bean.spmk;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author Tang 2020-04-17
 */
@Entity
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "spmk_executor")
@ApiModel("执行人")
public class SpmkExecutor extends Model<SpmkExecutor> {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号 编号", example = "101")
	private Integer id;

	@ApiModelProperty(value = "审批执行记录id 审批执行记录id", example = "101")
	private Integer approveExecuteRecordId;

	@ApiModelProperty(value = "执行人id 执行人id", example = "101")
	private Integer empNum;

	@ApiModelProperty(value = "执行人名称 ", example = "执行人名称")
	private String executorName;

	@ApiModelProperty(value = "执行人头像url ", example = "执行人头像url")
	private String operatorHeaderUrl;

	@ApiModelProperty(value = "意见 ", example = "意见")
	private String opinion;

	@ApiModelProperty(value = "状态 0未执行 1执行中 2同意 3拒接 4转派", example = "101")
	private Integer sts;

	@ApiModelProperty(value = "阅读标记0.未读 1.已读", example = "0")
	private Integer readStatus;

	@TableField(fill = FieldFill.INSERT)
	@ApiModelProperty(value = "创建时间 ", example = "创建时间")
	private Date createTime;

	@TableField(fill = FieldFill.UPDATE)
	@ApiModelProperty(value = "创建时间 ", example = "创建时间")
	private Date updateTime;

	@ApiModelProperty(value = "签字图片 ", example = "签字图片")
	private String signatureImg;

}