package cn.timer.api.dto.spmk;

import cn.timer.api.config.exception.ValidationMsg;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class AdminApprovingDto {

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "审批汇总id", example = "2", required = true)
	private Integer asId;

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "审批执行记录id", example = "10", required = true)
	private Integer executeRecordId;

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "执行人记录id", example = "10", required = true)
	private Integer executorId;

	@ApiModelProperty(value = "意见", example = "同意、拒绝")
	private String opinion;

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "状态 2同意 3拒绝 4转派", example = "2", required = true)
	private Integer sts;

	@ApiModelProperty(value = "被转派人 ", example = "对象")
	private User user;

	@ApiModelProperty(value = "签字图片 ", example = "签字图片")
	private String signatureImg;

	@ApiModelProperty(value = "被转派人数组 ", example = "数组")
	private List<User> userList;

	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value = "申请数据 ", example = "申请数据", required = true)
	private Integer execute;

	@ApiModelProperty(value = "节点索引 ", example = "节点索引", required = true)
	private Integer typeIndex;

	@ApiModelProperty(value = "节点用户索引 ", example = "节点用户索引", required = true)
	private Integer userIndex;

}
