package cn.timer.api.dto.spmk;

import java.util.Date;
import java.util.List;

import cn.hutool.json.JSONObject;
import cn.timer.api.bean.spmk.SpmkApproveExecuteRecord;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class SpmkApproveDetailDto {

	@ApiModelProperty(value = "编号 编号", example = "101")
	private Integer id;

	@ApiModelProperty(value = "审批汇总id 审批汇总id", example = "101")
	private Integer approveSummaryId;

	@ApiModelProperty(value = "标题 ", example = "标题")
	private String name;

	@ApiModelProperty(value = "副标题 ", example = "副标题")
	private String digest;

	@ApiModelProperty(value = "所在部门名称 ", example = "所在部门名称")
	private String departmentName;

	@ApiModelProperty(value = "申请数据 ", example = "申请数据")
	private JSONObject requestData;

	@ApiModelProperty(value = "审批表单 ", example = "审批表单")
	private List<JSONObject> froms;

	@ApiModelProperty(value = "审批流程 ", example = "审批流程")
	private Router router;

	@ApiModelProperty(value = "通过节点", example = "通过节点")
	private List<FlowChildren> flowChildren;

	@ApiModelProperty(value = "审批执行记录 ", example = "审批执行记录")
	private List<SpmkApproveExecuteRecord> approveExecuteRecord;

	private Integer empNum;

	private Integer sts;

	private Integer executeEmpNum;//当前审批中 当前执行人的id

	private Integer executeSts;

	private Integer exeid;

	private Integer exereid;

	private Date launchTime; //审批发起时间

	private Integer index;//插入审批人的索引

	private Integer userIndex;//插入审批人的当前用户索引

}
